/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         armoise_parse
#define yylex           armoise_lex
#define yyerror         armoise_error
#define yydebug         armoise_debug
#define yynerrs         armoise_nerrs

#define yylval          armoise_lval
#define yychar          armoise_char

/* Copy the first part of user declarations.  */
#line 29 "armoise/armoise-syntax.y" /* yacc.c:339  */

#include <ccl/ccl-memory.h>
#include "armoise/armoise-input-p.h"

#define YYDEBUG 1
#define YYSTYPE armoise_tree *

#define ZN ((armoise_tree *) NULL)

#define NN(_type,_vtype,_child,_next) _NN (_type, #_type, _vtype, _child, _next)

#define NE(_type,_child,_next) NN (_type, CCL_PARSE_TREE_EMPTY, _child, _next)
#define U_NE(_type,_child) NE (_type,_child, ZN)
#define B_NE(_result, _type,_child1,_child2)	\
  do { \
    armoise_tree *aux_ = U_NE (_type, _child1); \
    (_child1)->next = (_child2); \
    (_result) = aux_; \
  } while (0)

#define NID()  NN (ARMOISE_TREE_IDENTIFIER, CCL_PARSE_TREE_IDENT, ZN, ZN)
#define NINT() NN (ARMOISE_TREE_INTEGER, CCL_PARSE_TREE_INT, ZN, ZN)
#define NSTR() NN (ARMOISE_TREE_STRING, CCL_PARSE_TREE_STRING, ZN, ZN)

# define SL(_x_) do { (_x_)->line = armoise_current_line; } while (0)

#define malloc  ccl_malloc
#define realloc ccl_realloc
#define calloc  ccl_calloc
#define free    ccl_free

armoise_tree *armoise_syntax_tree;
armoise_tree *armoise_syntax_tree_container;

# define NODES armoise_syntax_tree_container

# define MAX_NB_SYNTAX_ERROR 100

 int armoise_number_of_errors;

static armoise_tree *
_NN (int type, const char *type_string, ccl_parse_tree_value_type vtype, 
     armoise_tree *child, armoise_tree *next)
{
  NODES = 
    ccl_parse_tree_create (type, type_string, vtype, 
			   (child == ZN 
			    ? armoise_current_line 
			    : child->line),
			   (child == ZN
			    ? armoise_current_filename
			    : child->filename),
			   child, next, NODES);
  return NODES;
}

static armoise_tree *
s_make_range (int min, int max, int in_nat);

static armoise_tree *
s_make_rewrite_simple_set_prototype (armoise_tree *proto, armoise_tree *dom,
                                     armoise_tree *formula);


#line 139 "armoise-syntax.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "armoise/armoise-syntax.h".  */
#ifndef YY_ARMOISE_ARMOISE_SYNTAX_TAB_H_INCLUDED
# define YY_ARMOISE_ARMOISE_SYNTAX_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int armoise_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_IDENTIFIER = 258,
    TOK_ASSIGN = 259,
    TOK_LET = 260,
    TOK_IN = 261,
    TOK_UINT = 262,
    TOK_NATURALS = 263,
    TOK_INTEGERS = 264,
    TOK_POSITIVES = 265,
    TOK_REALS = 266,
    TOK_LEQ = 267,
    TOK_GEQ = 268,
    TOK_NEQ = 269,
    TOK_IMPLY = 270,
    TOK_EQUIV = 271,
    TOK_UNION = 272,
    TOK_INTERSECTION = 273,
    TOK_AND = 274,
    TOK_OR = 275,
    TOK_NOT = 276,
    TOK_ERROR = 277,
    TOK_TRUE = 278,
    TOK_FALSE = 279,
    TOK_EMPTY = 280,
    TOK_DOTS = 281,
    UMINUS = 282,
    UPLUS = 283,
    TOK_EXISTS = 284,
    TOK_FORALL = 285,
    UMINUS_ARITH = 286,
    UPLUS_ARITH = 287
  };
#endif
/* Tokens.  */
#define TOK_IDENTIFIER 258
#define TOK_ASSIGN 259
#define TOK_LET 260
#define TOK_IN 261
#define TOK_UINT 262
#define TOK_NATURALS 263
#define TOK_INTEGERS 264
#define TOK_POSITIVES 265
#define TOK_REALS 266
#define TOK_LEQ 267
#define TOK_GEQ 268
#define TOK_NEQ 269
#define TOK_IMPLY 270
#define TOK_EQUIV 271
#define TOK_UNION 272
#define TOK_INTERSECTION 273
#define TOK_AND 274
#define TOK_OR 275
#define TOK_NOT 276
#define TOK_ERROR 277
#define TOK_TRUE 278
#define TOK_FALSE 279
#define TOK_EMPTY 280
#define TOK_DOTS 281
#define UMINUS 282
#define UPLUS 283
#define TOK_EXISTS 284
#define TOK_FORALL 285
#define UMINUS_ARITH 286
#define UPLUS_ARITH 287

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE armoise_lval;

int armoise_parse (void);

#endif /* !YY_ARMOISE_ARMOISE_SYNTAX_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 254 "armoise-syntax.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  54
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   472

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  55
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  29
/* YYNRULES -- Number of rules.  */
#define YYNRULES  97
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  182

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   287

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,     2,     2,    35,    34,    39,     2,
      49,    50,    32,    30,    48,    31,     2,    33,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    47,
      41,    40,    42,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    51,    27,    52,    28,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    53,    38,    54,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    36,    37,    43,    44,    45,    46
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   129,   129,   132,   136,   141,   143,   148,   150,   156,
     161,   163,   168,   173,   175,   180,   186,   188,   190,   195,
     200,   202,   207,   212,   214,   220,   225,   227,   229,   231,
     233,   235,   237,   239,   241,   243,   245,   247,   249,   251,
     253,   255,   257,   259,   261,   263,   265,   267,   269,   271,
     276,   281,   283,   288,   290,   295,   297,   299,   305,   308,
     313,   315,   320,   325,   327,   329,   331,   333,   335,   337,
     339,   341,   343,   345,   347,   349,   351,   353,   358,   360,
     362,   364,   366,   368,   373,   375,   380,   382,   388,   390,
     392,   394,   396,   398,   400,   402,   403,   405
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_IDENTIFIER", "TOK_ASSIGN",
  "TOK_LET", "TOK_IN", "TOK_UINT", "TOK_NATURALS", "TOK_INTEGERS",
  "TOK_POSITIVES", "TOK_REALS", "TOK_LEQ", "TOK_GEQ", "TOK_NEQ",
  "TOK_IMPLY", "TOK_EQUIV", "TOK_UNION", "TOK_INTERSECTION", "TOK_AND",
  "TOK_OR", "TOK_NOT", "TOK_ERROR", "TOK_TRUE", "TOK_FALSE", "TOK_EMPTY",
  "TOK_DOTS", "'\\\\'", "'^'", "'!'", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'$'", "UMINUS", "UPLUS", "'|'", "'&'", "'='", "'<'", "'>'",
  "TOK_EXISTS", "TOK_FORALL", "UMINUS_ARITH", "UPLUS_ARITH", "';'", "','",
  "'('", "')'", "'['", "']'", "'{'", "'}'", "$accept",
  "grammar_start_rule", "armoise_description",
  "definition_or_predicate_list", "definition_or_predicate",
  "predicate_definition", "identifier_or_tuple", "tuple_of_identifiers",
  "list_of_tuples", "identifier", "predicate", "local_context",
  "list_of_predicate_definitions",
  "tuple_of_predicates_without_local_context",
  "list_of_tuple_of_predicates", "predicate_without_local_context", "set",
  "integer", "list_element", "list_of_boolean_combinations", "simple_set",
  "range", "list_of_terms", "vector_of_terms", "formula",
  "term_comparison", "quantified_formula", "typed_identifier", "term", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,    92,    94,    33,
      43,    45,    42,    47,    37,    36,   282,   283,   124,    38,
      61,    60,    62,   284,   285,   286,   287,    59,    44,    40,
      41,    91,    93,   123,   125
};
# endif

#define YYPACT_NINF -119

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-119)))

#define YYTABLE_NINF -12

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     137,  -119,    -2,  -119,  -119,  -119,  -119,  -119,  -119,   294,
      11,   294,    -2,   294,    11,     5,    24,  -119,  -119,   -15,
    -119,    42,  -119,    44,  -119,   236,  -119,   437,  -119,    20,
    -119,  -119,    25,  -119,    43,  -119,   149,  -119,  -119,    26,
      10,   394,    27,   -10,    11,     5,     5,    77,  -119,    20,
      38,    82,   -21,   -11,  -119,   137,   265,   294,  -119,  -119,
     294,   294,   294,   294,   294,   294,   294,   294,   294,    11,
      11,    -2,  -119,    -2,  -119,   294,  -119,  -119,    11,    11,
    -119,  -119,  -119,    53,   294,  -119,   294,   305,  -119,     5,
       5,     5,     5,     5,     5,  -119,  -119,    51,    57,   345,
     149,   345,   345,   177,   177,    72,    72,    72,  -119,    56,
    -119,  -119,   418,  -119,    60,    62,  -119,  -119,  -119,   305,
    -119,  -119,   305,     4,     4,   305,    66,   116,  -119,  -119,
     376,     8,     8,  -119,  -119,  -119,  -119,  -119,   294,  -119,
    -119,  -119,  -119,  -119,    77,    82,   305,   305,   198,   325,
    -119,   305,   305,   305,   305,   305,   305,  -119,   294,     5,
       5,     5,     5,     5,     5,  -119,  -119,  -119,  -119,  -119,
    -119,    14,    12,    12,    14,   437,   200,   200,   200,   200,
     200,   200
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,    15,     0,    50,    45,    46,    47,    48,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     2,     4,     0,
       8,     0,    10,    51,     7,     0,    16,    25,    43,    40,
      39,    41,     0,    11,     0,    51,    30,    44,    36,    14,
       0,     0,     0,     0,     0,     0,     0,    51,    96,    95,
       0,    94,     0,    61,     1,     6,     0,     0,    17,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,    19,     0,    12,     0,    38,    37,     0,     0,
      97,    94,    93,     0,     0,    55,     0,     0,    57,     0,
       0,     0,     0,     0,     0,     5,     9,     0,    24,    26,
      29,    27,    28,    31,    32,    33,    34,    35,    42,     0,
      20,    13,    54,    53,     0,     0,    62,    86,    87,     0,
      76,    77,     0,     0,     0,     0,    51,     0,    69,    70,
       0,    88,    89,    90,    91,    92,    60,    22,     0,    52,
      58,    59,    72,    71,     0,     0,     0,     0,     0,    61,
      75,     0,     0,     0,     0,     0,     0,    56,     0,     0,
       0,     0,     0,     0,     0,    23,    84,    85,    74,    68,
      67,    66,    64,    63,    65,    73,    82,    83,    79,    78,
      80,    81
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -119,  -119,  -119,    67,  -119,     2,     3,  -119,    48,   104,
      61,  -119,    52,  -119,    -8,     1,   140,     0,    34,    58,
    -119,  -119,   -12,   -13,   249,  -119,  -119,  -118,    35
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    16,    17,    18,    19,    20,    21,    22,    40,    35,
      24,    25,    34,    58,    97,    26,    27,    48,    49,    42,
      30,    31,    83,    81,   127,   128,   129,    52,   130
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      28,     1,    51,    50,    32,   146,   147,     1,     1,    28,
      37,    28,     3,    28,    43,    39,    78,    87,     3,    89,
      90,    91,    92,    93,    54,    28,    59,   151,   152,   151,
     152,   153,    55,    88,    29,    44,    45,    94,    79,    12,
      91,    92,    93,    29,    80,    29,    56,    29,   -11,    72,
      53,   156,    74,    46,    46,    28,    28,    28,    98,    29,
      28,    28,    28,    28,    28,    28,    28,    28,    28,   108,
     109,    70,    71,    32,    73,    28,    39,    77,   114,   115,
      82,    53,   136,    84,    28,   117,    28,   118,    86,    29,
      29,    29,    85,   137,    29,    29,    29,    29,    29,    29,
      29,    29,    29,   116,    23,   138,    33,    69,   139,    29,
     145,   145,   140,   150,   141,    46,    33,    96,    29,    47,
      29,   111,    95,   110,   131,   132,   133,   134,   135,    53,
     165,   151,   152,   113,     0,   153,   154,     0,    28,    98,
       1,     0,     2,     0,     3,     4,     5,     6,     7,    36,
       0,    38,     0,    41,   155,   156,     0,     0,    28,    23,
     149,     0,     8,     0,     0,     0,     9,    10,    11,     0,
     157,     0,    29,     0,     0,    33,     0,    33,    12,    64,
      65,    66,    67,    68,    69,     0,    13,     0,    14,     0,
      15,   126,    29,     0,   176,   177,   178,   179,   180,   181,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    66,
      67,    68,    69,   151,   152,   112,     0,   153,   154,     0,
       0,     0,     0,   126,     0,     0,   126,   144,   144,   126,
      89,    90,    91,    92,    93,     0,   155,   156,     0,     1,
       0,     0,     0,     3,     4,     5,     6,     7,   168,     0,
     126,   126,     0,     0,     0,   126,   126,   126,   126,   126,
     126,     8,     0,     0,     0,     9,    10,    11,     1,     0,
       2,     0,     3,     4,     5,     6,     7,    57,     0,     0,
       0,     0,     0,     0,     0,    13,     0,    14,     0,    15,
       8,     0,     0,     0,     9,    10,    11,     1,   175,     0,
       0,     3,     4,     5,     6,     7,     0,     0,     1,     0,
       0,     0,     3,     0,    13,     0,    14,     0,    15,     8,
       0,     0,     0,     9,    10,    11,   119,     0,   120,   121,
       0,   158,     0,     0,   122,    44,    45,   159,   160,   161,
       0,     0,     0,    13,     0,    14,     0,    15,   123,   124,
       0,     0,     0,     0,   125,    89,    90,    91,    92,    93,
       0,     0,     0,    61,     0,   162,   163,   164,   142,     0,
       0,   143,     0,    94,   148,    64,    65,    66,    67,    68,
      69,     0,   158,     0,     0,     0,     0,     0,   159,   160,
     161,     0,     0,     0,     0,   166,   167,     0,     0,     0,
     169,   170,   171,   172,   173,   174,    89,    90,    91,    92,
      93,    60,    61,     0,     0,     0,   162,   163,   164,     0,
       0,    62,    63,     0,    64,    65,    66,    67,    68,    69,
       0,     0,     0,     0,     0,    60,    61,     0,     0,     0,
       0,     0,    75,     0,    76,    62,    63,     0,    64,    65,
      66,    67,    68,    69,    60,    61,     0,     0,     0,     0,
       0,     0,     0,     0,    62,    63,    75,    64,    65,    66,
      67,    68,    69
};

static const yytype_int16 yycheck[] =
{
       0,     3,    15,    15,     2,   123,   124,     3,     3,     9,
      10,    11,     7,    13,    14,    12,    26,    38,     7,    30,
      31,    32,    33,    34,     0,    25,    25,    15,    16,    15,
      16,    19,    47,    54,     0,    30,    31,    48,    48,    41,
      32,    33,    34,     9,    44,    11,     4,    13,     4,     6,
      15,    39,    42,    49,    49,    55,    56,    57,    57,    25,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    51,    47,    71,    48,    75,    73,    50,    78,    79,
      45,    46,    94,     6,    84,    84,    86,    86,     6,    55,
      56,    57,    54,    42,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    50,     0,    48,     2,    35,    52,    75,
     123,   124,    52,   126,    52,    49,    12,    56,    84,    15,
      86,    73,    55,    71,    89,    90,    91,    92,    93,    94,
     138,    15,    16,    75,    -1,    19,    20,    -1,   138,   138,
       3,    -1,     5,    -1,     7,     8,     9,    10,    11,     9,
      -1,    11,    -1,    13,    38,    39,    -1,    -1,   158,    55,
     125,    -1,    25,    -1,    -1,    -1,    29,    30,    31,    -1,
      54,    -1,   138,    -1,    -1,    71,    -1,    73,    41,    30,
      31,    32,    33,    34,    35,    -1,    49,    -1,    51,    -1,
      53,    87,   158,    -1,   159,   160,   161,   162,   163,   164,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    32,
      33,    34,    35,    15,    16,    75,    -1,    19,    20,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,
      30,    31,    32,    33,    34,    -1,    38,    39,    -1,     3,
      -1,    -1,    -1,     7,     8,     9,    10,    11,    50,    -1,
     146,   147,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,    25,    -1,    -1,    -1,    29,    30,    31,     3,    -1,
       5,    -1,     7,     8,     9,    10,    11,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    51,    -1,    53,
      25,    -1,    -1,    -1,    29,    30,    31,     3,   158,    -1,
      -1,     7,     8,     9,    10,    11,    -1,    -1,     3,    -1,
      -1,    -1,     7,    -1,    49,    -1,    51,    -1,    53,    25,
      -1,    -1,    -1,    29,    30,    31,    21,    -1,    23,    24,
      -1,     6,    -1,    -1,    29,    30,    31,    12,    13,    14,
      -1,    -1,    -1,    49,    -1,    51,    -1,    53,    43,    44,
      -1,    -1,    -1,    -1,    49,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    18,    -1,    40,    41,    42,   119,    -1,
      -1,   122,    -1,    48,   125,    30,    31,    32,    33,    34,
      35,    -1,     6,    -1,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,   146,   147,    -1,    -1,    -1,
     151,   152,   153,   154,   155,   156,    30,    31,    32,    33,
      34,    17,    18,    -1,    -1,    -1,    40,    41,    42,    -1,
      -1,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    17,    18,    -1,    -1,    -1,
      -1,    -1,    48,    -1,    50,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    27,    28,    48,    30,    31,    32,
      33,    34,    35
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     5,     7,     8,     9,    10,    11,    25,    29,
      30,    31,    41,    49,    51,    53,    56,    57,    58,    59,
      60,    61,    62,    64,    65,    66,    70,    71,    72,    73,
      75,    76,    60,    64,    67,    64,    71,    72,    71,    61,
      63,    71,    74,    72,    30,    31,    49,    64,    72,    73,
      77,    78,    82,    83,     0,    47,     4,    41,    68,    70,
      17,    18,    27,    28,    30,    31,    32,    33,    34,    35,
      51,    47,     6,    48,    42,    48,    50,    50,    26,    48,
      72,    78,    83,    77,     6,    54,     6,    38,    54,    30,
      31,    32,    33,    34,    48,    58,    65,    69,    70,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    72,    72,
      67,    63,    71,    74,    72,    72,    50,    70,    70,    21,
      23,    24,    29,    43,    44,    49,    64,    79,    80,    81,
      83,    83,    83,    83,    83,    83,    77,    42,    48,    52,
      52,    52,    79,    79,    64,    78,    82,    82,    79,    83,
      78,    15,    16,    19,    20,    38,    39,    54,     6,    12,
      13,    14,    40,    41,    42,    69,    79,    79,    50,    79,
      79,    79,    79,    79,    79,    71,    83,    83,    83,    83,
      83,    83
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    55,    56,    56,    57,    58,    58,    59,    59,    60,
      61,    61,    62,    63,    63,    64,    65,    65,    65,    66,
      67,    67,    68,    69,    69,    70,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      72,    73,    73,    74,    74,    75,    75,    75,    76,    76,
      77,    77,    78,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    80,    80,
      80,    80,    80,    80,    81,    81,    82,    82,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     3,     2,     1,     1,     3,
       1,     1,     3,     3,     1,     1,     1,     2,     2,     3,
       3,     2,     3,     3,     1,     1,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     2,     3,     3,     1,
       1,     1,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     3,     3,     5,     3,     5,     5,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     2,     2,     3,     3,     2,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     1,     1,     1,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 130 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { armoise_syntax_tree = (yyvsp[0]); }
#line 1523 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 132 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { armoise_syntax_tree = ZN; }
#line 1529 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 137 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1535 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 142 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyvsp[-2])->next = (yyvsp[0]); }
#line 1541 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 144 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 1547 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 149 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1553 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 151 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1559 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 157 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_DEFINITION, (yyvsp[-2]), (yyvsp[0]));  }
#line 1565 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 162 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1571 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 164 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1577 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 169 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_ID_TUPLE, (yyvsp[-1]));  }
#line 1583 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 174 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyvsp[-2])->next = (yyvsp[0]); }
#line 1589 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 176 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1595 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 181 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NID (); (yyval)->value = armoise_token_value; SL ((yyval)); }
#line 1601 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 187 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_PREDICATE, (yyvsp[0])); }
#line 1607 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 189 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_PREDICATE, (yyvsp[-1]), (yyvsp[0])); }
#line 1613 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 191 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_PREDICATE, (yyvsp[-1]), (yyvsp[0])); }
#line 1619 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 196 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_PREDICATE_CONTEXT, (yyvsp[-1])); }
#line 1625 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 201 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyvsp[-2])->next = (yyvsp[0]); }
#line 1631 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 203 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 1637 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 208 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_PREDICATE_TUPLE, (yyvsp[-1])); }
#line 1643 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 213 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyvsp[-2])->next = (yyvsp[0]); }
#line 1649 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 215 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1655 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 221 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1661 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 226 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_UNION, (yyvsp[-2]), (yyvsp[0])); }
#line 1667 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 228 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_DIFFERENCE, (yyvsp[-2]), (yyvsp[0])); }
#line 1673 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 230 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_XOR, (yyvsp[-2]), (yyvsp[0])); }
#line 1679 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 232 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_INTERSECTION, (yyvsp[-2]), (yyvsp[0])); }
#line 1685 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 234 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_COMPLEMENT, (yyvsp[0])); }
#line 1691 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 236 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_PLUS, (yyvsp[-2]), (yyvsp[0])); }
#line 1697 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 238 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_MINUS, (yyvsp[-2]), (yyvsp[0])); }
#line 1703 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 240 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_MUL, (yyvsp[-2]), (yyvsp[0])); }
#line 1709 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 242 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_DIV, (yyvsp[-2]), (yyvsp[0])); }
#line 1715 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 244 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_MOD, (yyvsp[-2]), (yyvsp[0])); }
#line 1721 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 246 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_NEG, (yyvsp[0])); }
#line 1727 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 248 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_CARTESIAN_PRODUCT, (yyvsp[-1])); }
#line 1733 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 250 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_PAREN, (yyvsp[-1])); }
#line 1739 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 252 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1745 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 254 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1751 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 256 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1757 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 258 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_POWER, (yyvsp[-2]), (yyvsp[0])); }
#line 1763 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 260 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1769 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 262 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1775 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 264 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NE (ARMOISE_TREE_NATURALS, ZN, ZN); }
#line 1781 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 266 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NE (ARMOISE_TREE_INTEGERS, ZN, ZN); }
#line 1787 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 268 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NE (ARMOISE_TREE_POSITIVES, ZN, ZN); }
#line 1793 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 270 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NE (ARMOISE_TREE_REALS, ZN, ZN); }
#line 1799 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 272 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NE (ARMOISE_TREE_EMPTY, ZN, ZN); }
#line 1805 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 277 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NINT (); (yyval)->value = armoise_token_value; SL((yyval)); }
#line 1811 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 282 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1817 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 284 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_LIST_ELEMENT, (yyvsp[-3]), (yyvsp[-1])); }
#line 1823 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 289 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyvsp[-2])->next = (yyvsp[0]); }
#line 1829 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 291 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyvsp[-2])->next = (yyvsp[0]); }
#line 1835 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 296 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_ENUMERATED_SET, (yyvsp[-1])); }
#line 1841 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 298 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE((yyval), ARMOISE_TREE_SET, (yyvsp[-3]), (yyvsp[-1])); }
#line 1847 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 300 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { armoise_tree *F = U_NE(ARMOISE_TREE_TRUE, ZN);
    B_NE((yyval), ARMOISE_TREE_SET, (yyvsp[-1]), F); }
#line 1854 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 306 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = s_make_range ((yyvsp[-3])->value.int_value, (yyvsp[-1])->value.int_value, 1); 
  ccl_parse_tree_delete_tree ((yyvsp[-3])); ccl_parse_tree_delete_tree ((yyvsp[-1])); }
#line 1861 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 309 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = s_make_range ((yyvsp[-3])->value.int_value, (yyvsp[-1])->value.int_value, 0); 
  ccl_parse_tree_delete_tree ((yyvsp[-3])); ccl_parse_tree_delete_tree ((yyvsp[-1])); }
#line 1868 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 314 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyvsp[-2])->next = (yyvsp[0]); }
#line 1874 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 316 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1880 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 321 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_VECTOR, (yyvsp[-1])); }
#line 1886 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 326 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_OR, (yyvsp[-2]), (yyvsp[0])); }
#line 1892 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 328 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_OR, (yyvsp[-2]), (yyvsp[0])); }
#line 1898 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 330 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_AND, (yyvsp[-2]), (yyvsp[0])); }
#line 1904 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 332 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_AND, (yyvsp[-2]), (yyvsp[0])); }
#line 1910 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 334 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_EQUIV, (yyvsp[-2]), (yyvsp[0])); }
#line 1916 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 336 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_IMPLY, (yyvsp[-2]), (yyvsp[0])); }
#line 1922 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 338 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1928 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 340 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 1934 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 342 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NE (ARMOISE_TREE_NOT, (yyvsp[0]), ZN); }
#line 1940 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 344 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = NE (ARMOISE_TREE_NOT, (yyvsp[0]), ZN); }
#line 1946 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 346 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_IN, (yyvsp[-2]), (yyvsp[0])); }
#line 1952 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 348 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_PAREN, (yyvsp[-1])); }
#line 1958 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 350 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_CALL, (yyvsp[-1]), (yyvsp[0])); }
#line 1964 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 352 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_TRUE, ZN); }
#line 1970 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 354 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_FALSE, ZN); }
#line 1976 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 359 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_EQ, (yyvsp[-2]), (yyvsp[0])); }
#line 1982 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 361 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_NEQ, (yyvsp[-2]), (yyvsp[0])); }
#line 1988 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 363 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_LT, (yyvsp[-2]), (yyvsp[0])); }
#line 1994 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 365 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_GT, (yyvsp[-2]), (yyvsp[0])); }
#line 2000 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 367 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_LEQ, (yyvsp[-2]), (yyvsp[0])); }
#line 2006 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 369 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_GEQ, (yyvsp[-2]), (yyvsp[0])); }
#line 2012 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 374 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_EXISTS, (yyvsp[0]), (yyvsp[-1])); }
#line 2018 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 376 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_FORALL, (yyvsp[0]), (yyvsp[-1])); }
#line 2024 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 381 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_IN, (yyvsp[-2]), (yyvsp[0])); }
#line 2030 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 383 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_IN, (yyvsp[-2]), (yyvsp[0])); }
#line 2036 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 389 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_PLUS, (yyvsp[-2]), (yyvsp[0])); }
#line 2042 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 391 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_MINUS, (yyvsp[-2]), (yyvsp[0])); }
#line 2048 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 393 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_MUL, (yyvsp[-2]), (yyvsp[0])); }
#line 2054 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 395 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_DIV, (yyvsp[-2]), (yyvsp[0])); }
#line 2060 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 397 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { B_NE ((yyval), ARMOISE_TREE_MOD, (yyvsp[-2]), (yyvsp[0])); }
#line 2066 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 399 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = U_NE (ARMOISE_TREE_NEG, (yyvsp[0])); }
#line 2072 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 401 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2078 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 404 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2084 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 406 "armoise/armoise-syntax.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2090 "armoise-syntax.tab.c" /* yacc.c:1646  */
    break;


#line 2094 "armoise-syntax.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 409 "armoise/armoise-syntax.y" /* yacc.c:1906  */


static armoise_tree *
s_make_range (int minv, int maxv, int in_nat)
{
  armoise_tree *proto = NID ();
  armoise_tree *min = NINT ();
  armoise_tree *max = NINT ();
  armoise_tree *min_leq_x = NID ();
  armoise_tree *x_leq_max = NID ();
  armoise_tree *result;
  armoise_tree *dom;

  proto->value.id_value = ccl_string_make_unique ("_x");
  min->value.int_value = minv;
  max->value.int_value = maxv;

  min_leq_x->value.id_value = ccl_string_make_unique ("_x");
  B_NE (min_leq_x, ARMOISE_TREE_LEQ, min, min_leq_x);

  x_leq_max->value.id_value = ccl_string_make_unique ("_x");
  B_NE (x_leq_max, ARMOISE_TREE_LEQ, x_leq_max, max);

  B_NE (result, ARMOISE_TREE_AND, min_leq_x, x_leq_max); 
  if (in_nat)
    dom = NE (ARMOISE_TREE_NATURALS, ZN, ZN);
  else if (minv >= 0)
    dom = NE (ARMOISE_TREE_POSITIVES, ZN, ZN);
  else
    dom = NE (ARMOISE_TREE_REALS, ZN, ZN);

  result = s_make_rewrite_simple_set_prototype (proto, dom, result);

  return result;
}

			/* --------------- */

static armoise_tree *
s_make_rewrite_simple_set_prototype (armoise_tree *proto, armoise_tree *dom,
                                     armoise_tree *formula)
{
  armoise_tree *result;
  armoise_tree *in;

  B_NE (in, ARMOISE_TREE_IN, proto, dom);
  if (formula == NULL)
    formula = U_NE(ARMOISE_TREE_TRUE, ZN);
  B_NE(result, ARMOISE_TREE_SET, in, formula);

  return result;
}
