/*
 * ccl-rusage.h -- A simple wrapper for getrusage
 * 
 * This file is a part of the C Common Library (CCL) project. 
 * 
 * See file AUTHORS and COPYING for copyright details.
 *
 */

#ifndef CCL_RUSAGE_H
# define CCL_RUSAGE_H

# include <ccl/ccl-common.h>

BEGIN_C_DECLS

extern int
ccl_getrusage (long *p_usertime, long *p_maxrss);

END_C_DECLS

#endif /* ! CCL_RUSAGE_H */
